from setuptools import setup, find_packages

with open("README.md", "r") as f:
    long_description = f.read()

__author__ = "Denis Mulyalin <d.mulyalin@gmail.com>"

setup(
    name="ttp_templates",
    version="0.1.2",
    author="Denis Mulyalin",
    author_email="d.mulyalin@gmail.com",
    description="Template Text Parser Templates collections",
    long_description=long_description,
    long_description_content_type="text/markdown",
    url="https://github.com/dmulyalin/ttp_templates",
    packages=find_packages(),
    extras_require={},
    include_package_data=True,
    package_data={
        "ttp_templates": [
            "platform/*.txt", 
            "yang/*.txt",
            "misc/*/*.txt"
            ]
    },
    data_files=[('', ['LICENSE'])],
    install_requires=[
        "ttp>=0.6.0"
    ],
    classifiers=[
        "Topic :: Utilities",
        "Programming Language :: Python :: 3.6",
        "Programming Language :: Python :: 3.7",
        "License :: OSI Approved :: MIT License",
        "Operating System :: OS Independent",
    ]
)
